package ec.multirun;
import ec.util.*;


/**
 * Abstract class meant to allow one to take process a file containing
 * an <code>AnoveDataStorage<code> and do "awk" and "tr" things to its
 * rows (i.e. extract columns, add/average columns together).
 * 
 * <p>Note that the API asks for a double out of every row, so you can't return multiple columns.
 * 
 * @author Gabriel Catalin Balan
 */
public abstract class AnovaDataStorageTableShrinker
{
	public void setup(final ParameterDatabase params, final Parameter base){}
	public abstract void processHeader(String line);
	public abstract double compute(String line);
	
}
