package ec.multirun;
import ec.util.*;

/**
 * This prints a single column from a a file containing
 * an <code>AnoveDataStorage<code>; you must specify the
 * name of the column.
 * 
 * 
 * @author Gabriel Catalin Balan
 */
public class HeaderExactMatchColumnExtractor extends HeaderMatchColumnExtractor
{
	public final String P_IGNORE_CASE = "ignore-case";
	boolean ignoreCase = false;
	public void setup(final ParameterDatabase params, final Parameter base)
	{
		super.setup(params, base);
		ignoreCase = params.getBoolean(base.push(P_IGNORE_CASE), null, ignoreCase);		
	}

	public void processHeader(String line)
	{
		String[] tokens = line.split("\t");
		for(int i=0; i<tokens.length; i++)
		{
			String s = tokens[i];
			boolean match = ignoreCase ? s.equalsIgnoreCase(namePattern) :  s.equals(namePattern);
			if(match) 
			{
				column = i;
				return;		
			}
		}
		throw new RuntimeException("No match for "+namePattern);
	}
}
