package sim.app.traffic.analysis;

/**
 * This graph shows the expected score of car on a n-intersection trip under the 1/LSF score-fn 
 * score_LSF(n) = Sum_{k=1}^{n}  P(k|n)/k
 * 
 * <p>P(k|n) = 1/n (when k<=n, obviously) since TL does not discriminate between 
 * cars at their first intersection and cars at their last.
 * 
 * 
 * <p>score<sub>LSF(n)</sub> = 1/n x Sum<sub>k=1...n</sub> 1/k
 * 
 * @author Gabriel Balan
 * 
 */
public class AvgLSFofTL
{
	static double[] tripLenProbs = new double[] { 6.75, 8.98, 10.47, 11.36,
			11.53, 11.14, 10.21, 8.82, 6.92, 5.01, 3.54, 2.35, 1.47, 0.84,
			0.42, 0.17, 0.04 };

	static double[] lsfValues = new double[tripLenProbs.length];

	public static void printNormalized()
	{
		double max = lsfValues[0];
		for (int i = 0; i < lsfValues.length; i++)
		{
			System.out.println((lsfValues[i] / max));
		}
	}

	public static void main(String[] args)
	{
		double oneOverK_sum = 0;
		for (int n = 1; n <= tripLenProbs.length; n++)
		{
			oneOverK_sum+=1d/n;
			lsfValues[n-1] = oneOverK_sum/n;
			//oneOverK_sum already contains sum(k=1...k) 1/k is 
		}
		printNormalized();
	}
}
