package sim.app.traffic.analysis;

import java.io.*;
import sim.util.jfreechart.*;

/**
 * @author Gabriel Balan
 *
 */
public class CrossTreatmentContributions2VarianceByTripLengthAnalysis
	extends CrossTreatmentTripDelayByLengthAnalysis
{

	public CrossTreatmentContributions2VarianceByTripLengthAnalysis(String[] args)throws IOException{super(args);}


	protected int getPlotCount(){return 1;}
	protected void addTreatmentToPlots(BufferedReader br, String name)throws IOException
	{
		TripDelayByLength analyzer = getTreatmentAnalyzer(br);
		plots[0].addSeries(analyzer.getContributionsToVarianceLine(name));
	}
	protected void writePlots()
	{
		PDFPrinter.printChartToPDF(getChart(plots[0], "Contributions to Variance of trip-averaged Delays"), "Contribs2TripAvgd-VarianceLinePlot.pdf");
	}


	protected TripDelayByLength getTreatmentAnalyzer(BufferedReader br)throws IOException
	{
		return new IndividualDelayByLength(br);
	}

	public static void main(String[] args)throws IOException
	{
		new CrossTreatmentContributions2VarianceByTripLengthAnalysis(args);
	}
}
