package sim.app.traffic.analysis;

import java.io.*;
import sim.util.jfreechart.*;

/**
 * @author Gabriel Balan
 *
 */
public class CrossTreatmentDelaysByTripLenNormalizedContribs
	extends CrossTreatmentTripDelayByLengthAnalysis
{

	public CrossTreatmentDelaysByTripLenNormalizedContribs(String[] args)throws IOException{super(args);}


	protected int getPlotCount(){return 1;}
	protected void addTreatmentToPlots(BufferedReader br, String name)throws IOException
	{
		TripDelayByLength analyzer = getTreatmentAnalyzer(br);
		plots[0].addSeries(analyzer.getNormalizedContributionsToAverageLine(name));
	}
	protected void writePlots()
	{
		PDFPrinter.printChartToPDF(getChart(plots[0], "Normalized Contributions to Average Trip-averaged Delay", "%"), "NContribs2TripAvgd-AvgsLinePlot.pdf");
	}


	public static void main(String[] args)throws IOException
	{
		new CrossTreatmentDelaysByTripLenNormalizedContribs(args);
	}
}
