package sim.app.traffic.analysis;

import java.io.*;
import sim.util.jfreechart.*;

/**
 * @author Gabriel Balan
 *
 */
public class CrossTreatmentIndividualDelaysByTripLengthAnalysis
	extends CrossTreatmentTripDelayByLengthAnalysis
{

	public CrossTreatmentIndividualDelaysByTripLengthAnalysis(String[] args)throws IOException{super(args);}


	protected int getPlotCount(){return 1;}
	protected void addTreatmentToPlots(BufferedReader br, String name)throws IOException
	{
		TripDelayByLength analyzer = getTreatmentAnalyzer(br);
		plots[0].addSeries(analyzer.getMedianLine(name));
	}
	protected void writePlots()
	{
		PDFPrinter.printChartToPDF(getChart(plots[0], "Median of Trip-averaged Delay"), "Indiv-MediansLinePlot.pdf");
	}


	protected TripDelayByLength getTreatmentAnalyzer(BufferedReader br)throws IOException
	{
		return new IndividualDelayByLength(br);
	}

	public static void main(String[] args)throws IOException
	{
		new CrossTreatmentIndividualDelaysByTripLengthAnalysis(args);
	}
}
