package sim.app.traffic.analysis;
import sim.util.*;
import java.io.*;
/**
 * @author Gabriel Balan
 *
 */
public interface TripDataAnalyzer extends Parametrizable
{
	void add(TripData data);
	void finish();
	
	
	public static class TripData
	{
		public TripData(DoubleBag delays, double wealth, double endTime)
		{
			delayBag = delays;
			finalWealth = wealth;
			finishingTime = endTime;
		}
		DoubleBag delayBag;
		double finalWealth;
		double finishingTime;
		public double getAverageDelay()
		{
			double sum=0;
			int n=delayBag.numObjs;
			for(int i=0;i<n;i++)
				sum+=delayBag.objs[i];
			return sum/n;
		}
		
		static TripData read(BufferedReader br, boolean extendedFormat)throws IOException
		{
			String line=br.readLine();
			if(line==null || line.equals(""))
				return null;
			String[] atoms = line.split("\t");

			double time = 0;
			double wealth = 0;
			int n = atoms.length;
			if(extendedFormat)
			{			
				time = Double.parseDouble(atoms[0]);
				wealth = Double.parseDouble(atoms[1]);
				n = atoms.length-2;
			}

			DoubleBag b = new DoubleBag();
			b.resize(n);

			for(int i=0;i<n;i++)
				b.add(Double.parseDouble(atoms[i]));

			return new TripData(b, wealth, time);
		}
		
		public void write(PrintWriter pw)
		{
			pw.print(finishingTime+"\t"+finalWealth+"\t");
			for(int i=0;i<delayBag.numObjs;i++)
				pw.print(delayBag.objs[i]+"\t");
			pw.println();

		}
		
	}
}
