package sim.app.traffic.analysis;
import sim.util.*;
import ec.util.*;
import java.io.*;
import java.util.zip.*;
import sim.app.traffic.*;

/**
 * It prints the average  each trip on a line, TAB separated.
 * 
 * @author Gabriel Balan
 */
public class TripDataFileLogger implements TripDataAnalyzer
{
	TrafficSim ts;
	PrintWriter pw;
	
	public static final String P_FILE = "file";
	public static final String P_ZIPPED = "zipped";
	
	


	public void setup(ParamSimState state, Parameter base) 
	{
		ts = (TrafficSim)state;
		File rawDataLogFile = state.parameters.getFile(base.push(P_FILE), null);
		try
		{
			if(state.parameters.getBoolean(new Parameter(P_ZIPPED), null, rawDataLogFile.getName().endsWith("gz")))
				pw = new PrintWriter(new GZIPOutputStream(new FileOutputStream(rawDataLogFile)), false);
			else
				pw = new PrintWriter(new FileOutputStream(rawDataLogFile), false);
		}catch(FileNotFoundException ex){ex.printStackTrace();}
		catch(IOException ex){ex.printStackTrace();}
		
	}
	

	public void add(TripData tripRecord)
	{
		if(ts.schedule.time()>ts.warmupPeriod)
			tripRecord.write(pw);
	}

//I need a hook to be called at the end.
	public void finish()
	{
		pw.close();
	}

		

	public Parameter defaultBase(){return null;}
	public Object simpleClone(){return null;}

}
