package sim.app.traffic.analysis;
import sim.app.traffic.car.*;
import sim.app.traffic.*;
import sim.util.*;
import ec.util.*;

/**
 *
 *  TODO make an abstract class that prepares a printwriter (zipped or not)
 *  and the implementators decide whether to write trip delays, 
 *  trip average delay, wealth, etc
 *  
 * @author Gabriel Balan
 */
public class TripLoggingCar extends Car
{
	
	//I don't clone the logger, it's "static on purpose.
	TripDataAnalyzer logger; 
	//this one should be cloned!
	DoubleBag tripDelays;
	

	public void setup(ParamSimState state, Parameter base) 
	{
		super.setup(state, base);
		Parameter p = base.push("logger");
		logger = (TripDataAnalyzer)state.parameters.getInstanceForParameter(p, null, TripDataAnalyzer.class);
		logger.setup(state, p);
	}
	
	public Object simpleClone()
	{
		TripLoggingCar newc = (TripLoggingCar)super.simpleClone();
		newc.tripDelays = new DoubleBag();
		return newc;
	}

	
	public void resetWealthAndWaitingTimes(TrafficSim ts, float initialWealth)
	{
		super.resetWealthAndWaitingTimes(ts, initialWealth);
		logger.add(new TripDataAnalyzer.TripData(	tripDelays, 
													this.wealth, 
													ts.schedule.time()));
		tripDelays.clear();
	}
	protected void recordCarDelay(TrafficSim ts, double delay)
	{
		super.recordCarDelay(ts, delay);
		tripDelays.add(delay);
	}
	
	public void finish(){logger.finish();}
}
