package sim.app.traffic.analysis.creditdeficit;
import sim.engine.*;
import sim.display.*;
import sim.app.traffic.*;
import sim.app.traffic.jfreechart.*;
import sim.app.traffic.grid.*;
import ec.util.*;
import java.io.*;
import javax.swing.*;


public class DeficitGridCityTrafficSimWithUI extends GridCityTrafficSimWithUI 
{
	//intersections' average deficit
	public Display2D displayD;
	public JFrame displayFrameD;

	CummulativeTrafficTallyTrace deficitTrace;
	
	
    public static void main(String[] args)
    {
		ParameterDatabase parameters=null;
		for(int x=0;x<args.length-1;x++)
			if (args[x].equals(TrafficSim.A_FILE))
			{
				try
				{
					parameters=new ParameterDatabase(
							new File(new File(args[x+1]).getAbsolutePath()),
							args);
				}catch(IOException ex){ex.printStackTrace();}
				break;
			}
		if (parameters==null)
			throw new RuntimeException("No parameter file was specified." );

		TrafficSim sim = new TrafficSim(parameters);
		
		DeficitGridCityTrafficSimWithUI simWithUI = new DeficitGridCityTrafficSimWithUI(sim);
		Console c = new Console(simWithUI);
		c.setVisible(true);
	}
	
    public DeficitGridCityTrafficSimWithUI(SimState state) 
    {
    	super(state); 
    	TrafficSim sim = (TrafficSim)state;
    	
		if (sim.warmupPeriod > 0)
			sim.schedule.scheduleOnce(sim.warmupPeriod, new Steppable() {
				public void step(SimState state) {
					DeficitTallyingFixedCompensation.resetStats();
				}
			});

    	
		deficitTrace = new DeficitTrace(sim, 64);
    	sim.addPhaseListener(deficitTrace);    		
    }
            
    public void init(Controller c)
    {
	    super.init(c);
		
		registerChart(createLineChart(	"Intersection's Average Credit Deficit",
										"Simulation time (s)", 
										"Credit", 
										deficitTrace.dataset),
					"Credit deficit",c);
	}
	
}
