package sim.app.traffic.compensation;
import sim.app.traffic.*;
import sim.util.*;
import ec.util.*;

/**
 * @author Gabriel Balan
 *
 */
public class FixedCompensation extends CompensationPolicy 
{
	public void distribute(Intersection inter, float amount) 
	{
		TrafficQueue[] queues = inter.queues;
		for(int i=0;i<queues.length;i++)
		{
			if(losersOnly&&inter.winnersMask[i]) continue;
			TrafficQueue q = queues[i];
			//TODO set the stats
			q.compensateFixedAmount(compensation, stoppedOnly);
		}

	}

	protected float compensation;
	public static final String P_AMOUNT = "amount";
	public static final String P_FIXED_COMPENSATION = "fixed-compensation";

	
	public void setup(ParamSimState state, Parameter base)
	{
		super.setup(state, base);
		compensation = state.parameters.getFloatWithDefault(base.push(P_AMOUNT), defaultBase().push(P_AMOUNT),0);
	}
	public Parameter defaultBase(){return new Parameter(P_FIXED_COMPENSATION);}
}
