package sim.app.traffic.grid;  
import sim.app.traffic.*;
import sim.field.network.*;
import sim.util.*;
/**
 * {n|s|w|e}x{in|out} can be -1 if no such edge
 * 
 * @author Gabriel Balan
 */
public interface GridNode extends Parametrizable{
	void netSetup(	TrafficSim ts, 
					Network.IndexOutIn ioi, 
					int nin, 
					int nout,
					int sin, 
					int sout,
					int ein, 
					int eout,
					int win, 
					int wout);
	//it's actually 
	void  setPosition(int x, int y);
	Int2D getCoords();
	int[] getOutEdgeIndices();
	
	//for portraying purposes
	int[] getInEdgeIndices();
	Network.IndexOutIn getIOI();
	static final int N = 0;
	static final int E = 1;
	static final int S = 2;
	static final int W = 3;	
	
	public static final String[] directionName = {"N", "E", "S", "W"};
	
	
}
