package sim.app.traffic.grid;
import java.awt.*;
import sim.app.traffic.*;
/**
 * This works with <code>GridNode</code> objects.
 * This is based on <code>RectanglePortrayal2D</code>, which is way faster than the default Oval...
 * 
 * @author Gabriel Balan
 */
public class GridNodeCountsPortrayal2D extends GridNodePortrayal2D
{
	public GridNodeCountsPortrayal2D() { super(); }
	public GridNodeCountsPortrayal2D(Paint paint) { super(paint); }
	public GridNodeCountsPortrayal2D(double scale) { super(scale); }
	public GridNodeCountsPortrayal2D(Paint paint, double scale){super(paint, scale);}
                
                
	protected boolean showInRangeStats(){return true;}
	protected String getInRangeStatText(TrafficQueue q){return (q.inRangeCars.size()-q.size())+"";}
	protected String getQueueStatText(TrafficQueue q){ return q.size()+"";}
}
