package sim.app.traffic.info;
import sim.app.traffic.car.*;
import sim.util.*;
import ec.util.*;

/**
 * @author Gabriel Balan
 *
 */
public class SegmentInfo implements Parametrizable, Valuable {
	public static final String P_SEG_INFO = "segment";
	public static final String P_LENGTH = "length";
	public static final String P_SENSOR_RANGE = "sensor-range";
	public double length;
	public double sensorRange; 
		
	public void setup(ParamSimState state, Parameter base) 
	{
		sensorRange = state.parameters.getDouble(base.push(P_SENSOR_RANGE),
										 defaultBase().push(P_SENSOR_RANGE),0);
		if(sensorRange<0) throw new RuntimeException("Invalid sensor range: "+sensorRange);

		length = state.parameters.getDouble(base.push(P_LENGTH),
										 defaultBase().push(P_LENGTH),sensorRange);
		if(length<sensorRange) throw new RuntimeException("Invalid segment length: "+length);
		
	}
	public Parameter defaultBase() {return new Parameter(P_SEG_INFO);}
	public Object simpleClone() 
	{
		return this;
	}
	public double doubleValue(){return length;}
	public void start(){}
	public void registerOutOfRange(Car c){}
	public void registerInRange(Car c){}
	public void unregister(Car c){}
	

}
