package sim.app.traffic.jfreechart;
import sim.app.traffic.*;
import sim.util.*;
import org.jfree.data.xy.*;


/**
 * @author Gabriel Balan
 *
 */
public class AverageQueueAverageLengthTrace implements TrafficSim.InfoDisplayUpdater
{
	
	final XYSeries[] series;
	public XYSeriesCollection dataset = new XYSeriesCollection();
	final int modulo;

	public AverageQueueAverageLengthTrace(int modulo)
	{
		this.modulo=modulo;
		series  = new XYSeries[2];
		boolean autoSort = false;
		//No thanx, I'll give JFreeChart the data already sorted.		
		boolean allowDuplicates = true;
		//I don't actually plan to have duplicates, 
		//but I don't want JFreeChart to get even slower by activelly preventing them.

		series[0] = new XYSeries("Global Avg", autoSort, allowDuplicates);
		series[1] = new XYSeries("Local Avg ("+modulo+" phases)", autoSort, allowDuplicates);

		
		for(int i=0;i<series.length;i++)dataset.addSeries(series[i]);
	}
	
	
	public void reset() {for(int i=0;i<series.length;i++) series[i].clear();}

	int index=0;	
	public void add(TrafficSim sim) 
	{	
		double t = sim.schedule.time();
		if(t<2*sim.roadNet.intersectionPrototype.phaseDuration+sim.warmupPeriod)
			return;
		boolean reset = false;	
		index++;
		if(index%modulo==0) 
		{
			index = 0;
			reset = true;
		}
		else
			return;
		Tally globalLenTally = sim.getAverageQueueLengthTally();
		Tally localLenTally = sim.getRecentAverageQueueLengthTally(reset);

		series[0].add(t, globalLenTally.getAverage());
		series[1].add(t, localLenTally.getAverage());
			
			
	}
}