package sim.app.traffic.jfreechart;


import sim.app.traffic.car.CarBagWithO1Remove;
import sim.app.traffic.load.TrafficLoadManager.*;
import sim.util.jfreechart.*;


/**
 * @author Gabriel Balan
 *
 */
public class WealthBoxAndWhiskerTrace extends WealthDistributionTrace 
{
	String name;
	int nBins = 15;
	int nTracePoints = 32;
	boolean skipBoxAndWhiskersOutliersTriplets = false;
	public BoxAndWhiskerSeries traceDataSet;
	
	public ClearableHistogramDataset lastSliceDataSet = new ClearableHistogramDataset();
	
	//although HistogramDAtaSet would seem more appropriate, I cannot remove/change data, 
	//and creating a new data set every time is not acceptable
	
	public WealthBoxAndWhiskerTrace(String name, boolean skipBoxAndWhiskersOutliersTriplets)
	{
		this.name = name;
		this.skipBoxAndWhiskersOutliersTriplets=skipBoxAndWhiskersOutliersTriplets;
	}

	public void reset()
	{
		traceDataSet = new BoxAndWhiskerSeries(name, nTracePoints);
//		System.out.println("new dataSet created");
		lastSliceDataSet.clearAndReport();//i.e. fireDatasetChanged;
	}

	double wealths[]=new double[100]; 

	
	public void addSlice(double time, CarBagWithO1Remove cars) 
	{
		int n = cars.size();
		if(wealths == null || wealths.length<n)
			wealths = new double[n];
		float sum=0;
		for(int i=0;i<n;i++)
		{
			wealths[i]= cars.get(i).wealth;
		}

		traceDataSet.add(new Double(time), sim.util.jfreechart.BoxAndWhiskerCalculator.calculateBoxAndWhiskerStatistics(wealths, n, traceDataSet.getOutlierCoefficient(), skipBoxAndWhiskersOutliersTriplets));

		lastSliceDataSet.clear();

////		if(lastSliceDataSet.getSeriesCount()>0)
////		{
////			java.util.List l = lastSliceDataSet.getBins(lastSliceDataSet.getSeriesCount()-1);
////			l.clear();
////		}
////		//I want to delete a series, not clear it.		
		
		//BoxAndWhiskerCalculator.calculateBoxAndWhiskerStatistics sorts the wealths!!!
		lastSliceDataSet.addSeries("Wealth Distribution", wealths, n, nBins, wealths[0], wealths[n-1]);
	}

}
