package sim.app.traffic.load;
import ec.util.*;
import sim.util.*;
/**
 * <ul>
 * <li>There are no frozen cars or sleeping cars.
 * <li>The number of cars is constant.
 * </ul>
 * @author Gabriel Balan
 */
public abstract class ConstantLoadManager extends TrafficLoadManager
{
	public static final String P_LOAD = "load";
	int load;
	public void setup(ParamSimState state, Parameter base)
	{
		super.setup(state, base);
		load = state.parameters.getInt(base.push(P_LOAD), defaultBase().push(P_LOAD), 1);
		if(load<=0)
			throw new RuntimeException("load has got to be > 0");
	}
	
	public void start()
	{
		super.start();		
		for(int i=0;i<load;i++) spawnACar();
	}
}
