package sim.app.traffic.load;
import sim.util.*;
import ec.util.*;
/**
 * ORIGIN-DESTINATION selector
 * @author Gabriel Balan
 */
public abstract class ODSelector implements Parametrizable 
{
	public Object simpleClone(){return null;}
	public abstract int getRandomSourceIndex(MersenneTwisterFast rng);
	public abstract int getRandomDestinationIndex(MersenneTwisterFast rng, int sourceIndex);

	static protected final int getRandomIndex(double prob, double[] cdf, int bottom, int top)	
	{
		int cur;
		while(top!=bottom)
		{
			cur = (top + bottom) / 2; // integer division
			if (cdf[cur] > prob)
				if (cur==0 || cdf[cur-1] <= prob)
					return exemptZeroes(cdf,cur);
				else // step down
					top = cur;
			else if (cur==cdf.length-1) // oops
				return exemptZeroes(cdf,cur);
			else if (bottom==cur) // step up
				bottom++;  // (8 + 9)/2 = 8
			else
				bottom = cur;  // (8 + 10) / 2 = 9
			}
		return exemptZeroes(cdf,bottom);  // oops		
	}
	
	/**
	 * copied from Sean Luke's RandomChoice.java
	 */
	private static final int exemptZeroes(final double[] probs, int index)
	{
		while(index > 0 && probs[index]==probs[index-1]) index--;
		return index;
	}
}
