package sim.app.traffic.load;
import sim.app.traffic.car.*;
import ec.util.*;
import sim.app.traffic.*;
/**
 * <ul>
 * <li>There are no frozen cars or sleeping cars.
 * <li>The number of cars is constant.
 * <li>When a car reaches its destination, it's given a new destination.
 * (i.e. the destination becomes the source)
 * <li>Every k trips the wealth of the car is reset.
 * </ul>
 * @author Gabriel Balan
 */
public class RandomODChainConstantLoadManager extends ConstantLoadManager
{
	public static final String P_SIMPLE_MANAGER = "random-OD-chain-traffic-load-manager";
	public Parameter defaultBase(){return new Parameter(P_SIMPLE_MANAGER);}

	public void destinationReached(Car car)
	{
		RoadNet net = tSim.roadNet;
		Intersection source = car.currentIntersection;
		int sourceIndex = source.ioi.index;
		int destinationIndex = odSelector.getRandomDestinationIndex(tSim.random, sourceIndex);	
//		System.out.println("Task: "+sourceIndex+" "+destinationIndex);
		Intersection destination = (Intersection)net.allNodes.objs[destinationIndex];
		
		if(resetWealthModuloTrips>0 && car.destinationsReached % resetWealthModuloTrips == 0)
				car.resetWealthAndWaitingTimes(tSim, tSim.initialWealth);
		car.deploy(tSim, source, tSim.itineraryFactory.getItinerary(source, destination, car));
	}
}
