package sim.app.traffic.load;
import sim.app.traffic.car.*;

import ec.util.*;
/**
 * <ul>
 * <li>There are no frozen cars or sleeping cars.
 * <li>When a car reaches its destination, it dies off
 * and a new one is spawned from a new Origin and with
 * a new Destination.  
 * 
 * @author Gabriel Balan
 */
public class RandomODConstantLoadManager extends ConstantLoadManager
{
	public static final String P_RAND_OD_CT_MANAGER = "random-OD-constant-load-manager";
	public Parameter defaultBase(){return new Parameter(P_RAND_OD_CT_MANAGER);}
	
	public void destinationReached(Car car)
	{
		if(resetWealthModuloTrips>0 && car.destinationsReached % resetWealthModuloTrips == 0)
				car.resetWealthAndWaitingTimes(tSim, tSim.initialWealth);
		canCar(car);
		spawnACar();
	}
}
