package sim.app.traffic.payment;
import sim.app.traffic.car.*;
import sim.util.*;
import ec.util.*;
/**
 *	A car pays what it bid, regardless of whether it passed through the intersection or not.
 *
 * @author Gabriel Balan
 */
public class PayBid implements PaymentPolicy 
{
	public float collect(Car c)
	{
		float c_bid =  c.currentBid;
		float c_wealth = c.wealth;
		if(c_wealth<c_bid)
			insufficientFund(c);
		c.wealth = c_wealth - c_bid;
		return c_bid;
	}
	private void insufficientFund(Car c)
	{
		throw new RuntimeException("Car "+c+"bid "+c.currentBid+" but is only worse "+c.wealth);
	}
	
	public void setup(ParamSimState state, Parameter base){}	
	public Parameter defaultBase(){return null;}
	public Object simpleClone(){return this;}
}
