package sim.app.traffic.payment;
import sim.app.traffic.car.*;
import sim.util.*;
import ec.util.*;
/**
 * A car pays a fixed amount when it passes.
 * 
 * @author Gabriel Balan
 */
public class PayFixedFee implements PaymentPolicy {
	float passageToll;
	public static final String P_TOLL = "toll";
	public static final String P_FIXED_TOLL = "fixed-passage-toll";
	public float collect(Car c)
	{
		float c_wealth = c.wealth;
		if(c_wealth<passageToll)
		{
			c.wealth = 0;
			return c_wealth;
		}
		c.wealth = c_wealth - passageToll;
		return passageToll;
	}
	
	public void setup(ParamSimState state, Parameter base)
	{
		passageToll = state.parameters.getFloatWithDefault(base.push(P_TOLL), defaultBase().push(P_TOLL),0);
	}	
	public Parameter defaultBase(){return new Parameter(P_FIXED_TOLL);}
	public Object simpleClone()
	{
		try{return clone();}catch(CloneNotSupportedException ex){return null;}
	}
}
