package sim.app.traffic.payment;
import sim.app.traffic.car.*;
import sim.util.*;
import ec.util.*;
/**
 * A car pays a fixed percentage of its wealth when it passes.
 * 
 * @author Gabriel Balan
 */
public class PayWealthPercentage implements PaymentPolicy {
	float passageTollFraction;
	public static final String P_TOLL = "fraction";
	public static final String P_PERCENTAGE_TOLL = "wealth-percentage-passage-toll";
	public float collect(Car c)
	{
		float c_wealth = c.wealth;
		float passageToll = c_wealth * passageTollFraction;
		c.wealth = c_wealth - passageToll;
		return passageToll;
	}
	
	public void setup(ParamSimState state, Parameter base)
	{
		passageTollFraction = state.parameters.getFloatWithDefault(base.push(P_TOLL), defaultBase().push(P_TOLL),0.1);
	}	
	public Parameter defaultBase(){return new Parameter(P_PERCENTAGE_TOLL);}
	public Object simpleClone()
	{
		try{return clone();}catch(CloneNotSupportedException ex){return null;}
	}
}
