package sim.app.traffic.queuewealth;

import ec.util.Parameter;
import sim.app.traffic.TrafficQueue;
import sim.util.ParamSimState;

/**
 * This returns 1 if the queue had green last time and 0 if not.
 * 
 * DON'T FORGET that a queue's wealth must be greater or equal to 0!!!!!
 * 
 * I could drop MultiQueueWealthWeightedSum and automatically subtract
 * a red-last-phase penalty (without going under zero).
 * 
 * @author Gabriel Balan
 */
public class LastPhaseColorSubsidy extends QueueWealthMetric 
{
	public static final String P_GREEN_AID = "green-aid";
	public static final String P_RED_AID = "red-aid";
	float greenAid = 1;
	float redAid = 0;
	
	public void setup(ParamSimState state, Parameter base)
	{
		greenAid = state.parameters.getFloatWithDefault(base.push(P_GREEN_AID), null, greenAid);
		redAid = state.parameters.getFloatWithDefault(base.push(P_RED_AID), null, redAid);
 
	}	
	
	public float getQueueWealth(TrafficQueue tq) {
		return (tq.greenLastTime)?greenAid:redAid;
	}

}
