package sim.app.traffic.queuewealth.delayincrease;

import sim.app.traffic.car.Car;
import sim.util.*;
import ec.util.*;

/**
 * Good for XP-aware TLCs
 * (TripLength-based traffic light Controllers)
 * (XP refers to the eXperienced delay over trips: 
 * rather than optimizing the average (and stdev) of the distribution of delays of all cars at all intersections,
 * you care about optimizing the (avg and stdev) of the distribution of trip-averaged delays.)
 * 
 * @author Gabriel Balan
 */
public class AverageWithExtraValue implements ExtraDelayContributionFunction {

	public double delayContributuion(Car c, double extraDelay) 
	{
		return c.waitingTimeTally.getAverageWithExtraValue(extraDelay);
	}
	
	public void setup(ParamSimState state, Parameter base){}	
	public Parameter defaultBase(){return null;}
	public Object simpleClone(){return null;}
}
