package sim.app.traffic.queuewealth.delayincrease;
import sim.app.traffic.*;
import sim.app.traffic.car.Car;

/**
 * 
 * This is the simplest of the DelayIncrease family of controllers
 * I want to isolate the 1/N behavior, so I can explain why CREDIT 
 * is so efficient. A car's score is 1, normalized by the contribution
 * function.
 * 
 * I want to see when CC/N is good, and when/why the compensations start 
 * makeing more sense (CREDIT-10 is more efficient than CREDIT-100).
 * 
 * @author Gabriel Balan
 */
public class DelayIncrease_v0 extends DelayIncrease_v1 
{
	public float getQueueWealth(TrafficQueue tq) 
	{
		float totalExtraDelay = 0;
		if(tq.inRangeCars.bag.numObjs==0)
			return totalExtraDelay;
		sim.util.Bag inRangeCarBag = tq.inRangeCars.bag;
		int numberInRangeCars = inRangeCarBag.numObjs;			
		for (int i = 0; i < numberInRangeCars; i++)
		{
			Car c = (Car) tq.inRangeCars.bag.objs[i];
			totalExtraDelay += (fn==null?1:fn.delayContributuion(c, 1));
		}

		return totalExtraDelay;
	}	
}
