package sim.app.traffic.queuewealth.delayincrease;
import sim.app.traffic.*;
import sim.app.traffic.car.Car;

/**
 * This is a small extension of DelayIncrease_v0, where
 * we replace the 1/N with 20/N when green_last_time and 
 * 15/N when red_last_time. (N is the contribution function, TripLengh or LenghSoFar).
 * 
 * @author Gabriel Balan
 */
public class DelayIncrease_v05 extends DelayIncrease_v1 
{
	public float getQueueWealth(TrafficQueue tq) 
	{
		double phaseDuration = tq.owner.phaseDuration;
		double penalty = tq.state.roadNet.intersectionCrossingDuration;		
		double delay = (tq.color == TrafficQueue.GREEN)? phaseDuration: phaseDuration-penalty;
		
		float totalExtraDelay = 0;
		if(tq.inRangeCars.bag.numObjs==0)
			return totalExtraDelay;
		sim.util.Bag inRangeCarBag = tq.inRangeCars.bag;
		int numberInRangeCars = inRangeCarBag.numObjs;			
		for (int i = 0; i < numberInRangeCars; i++)
		{
			Car c = (Car) tq.inRangeCars.bag.objs[i];
			totalExtraDelay += (fn==null?1:fn.delayContributuion(c, delay));
		}

		return totalExtraDelay;
	}	
}
