package sim.app.traffic.queuewealth.delayincrease;

import sim.app.traffic.car.Car;
import sim.app.traffic.route.FixedItinerary;
import sim.util.*;
import ec.util.*;
/**
 *
 * Good for XP optimizers.
 * It should be better than TripLenSoFarNormalization
 * but it requires more information than we were 
 * willing to ask for: 
 * 
 * It needs to know the size of the entire trip. So far
 * it only works with FixedItinerary, which is not so bad,
 * cause I only have FixedItineraries.
 * 
 * @author Gabriel Balan
 */
public class TripLenNormalization implements
		ExtraDelayContributionFunction {

	public double delayContributuion(Car c, double extraDelay) {
		int tripLen = ((FixedItinerary)c.getItinerary()).getNumberIntersesctions2Cross();
		return extraDelay/tripLen;
	}
	public void setup(ParamSimState state, Parameter base){}	
	public Parameter defaultBase(){return null;}
	public Object simpleClone(){return null;}

}
