package sim.app.traffic.rotation;
import sim.app.traffic.Intersection;
import sim.app.traffic.*;

/**
 *
 * Negative wealths could runis things for all of us.
 * 
 * @author Gabriel Balan
 */
public class WealthProportionate extends WealthiestFirst 
{
	static float[] tmpCumulative = new float[10];
	public int getWinningGroupIndex(TrafficSim simState, Intersection inter) 
	{
		//I have the queues memoize the queueWealth values 
		inter.updateQueueWealths();		
		float[] groupWealths = inter.groupWealths;
		float sum = 0;
		int nGroups = inter.groups.length;
		if(tmpCumulative.length<nGroups) tmpCumulative = new float[nGroups];
		for(int i=0;i<nGroups;i++)
		{
			float w_group_i=0;
			TrafficQueue[] group_i = inter.groups[i];
			for(int j=0;j<group_i.length;j++)
				w_group_i+= group_i[j].currentWealth;
			//TODO I could check for negative values

			sum+= groupWealths[i]=w_group_i;
			tmpCumulative[i]=sum;
		}
		if(sum==0)
			//if only flat-broke cars are waiting, choose based on car-count.
			//This assumes that the wealths are all >=0.
			return mostCarsGroup(simState, inter);

		//instead of normalizing tmpCumulative, I multiply the random value by sum. 
		float u = simState.random.nextFloat() *sum;
		int index=-1;
		for(int x=0;x<nGroups;x++)
			if (tmpCumulative[x] >u )
			{
				index = x;
				while(index > 0 && tmpCumulative[index]==tmpCumulative[index-1]) 
					index--;
				break;
			}		
		return index;
	}

}
