package sim.util;

import sim.engine.*;
import ec.util.*;

/**
 * @author Gabriel Catalin Balan
 */
public class ParamSimState extends SimState
{
	public final static String A_FILE = "-file";
	public final static String P_SEED = "seed"; 
	public final static String V_TIME = "time"; 

	public ParameterDatabase parameters;
	public ParamSimState(MersenneTwisterFast random, Schedule schedule, ParameterDatabase parameters)
		{
			super(random, schedule);
			this.parameters=parameters;
		}
	public ParamSimState(Schedule schedule, ParameterDatabase parameters)
	{
		this(new MersenneTwisterFast(retrieveSeed(parameters)), schedule, parameters);
	}
	public ParamSimState(ParameterDatabase parameters)
	{
		this( new Schedule(), parameters);
	}	
	public static long retrieveSeed(ParameterDatabase parameters)
	{
		String seedImg = parameters.getStringWithDefault(new Parameter(P_SEED), null, V_TIME);
		long seed = seedImg.equalsIgnoreCase(V_TIME)?
						System.currentTimeMillis():
						Long.parseLong(seedImg);
		System.out.println("Seed=\t"+seed);
		return seed;
	}
}
