package sim.util.doubledistribution;
import ec.util.*;


/**
 * @author Gabriel Catalin Balan
 *
 */
public class ConstantDoubleDistribution extends DoubleDistribution 
{
	double val;

	public static final String P_UNIF = "distibution.constant";
	public static final String P_VAL = "val";

	public Parameter defaultBase(){	return new Parameter(P_UNIF);}
	
	public void setup(ParameterDatabase parameters, Parameter base, MersenneTwisterFast random)
	{
		//I don't call super.setup(id, base, db) cause i don't need RNG.
		Parameter def = defaultBase();
		val = parameters.getDouble(base.push(P_VAL), def.push(P_VAL), Double.NEGATIVE_INFINITY);
	}
	public void setSeed(long seed){}
	public double getDouble()
	{
		return val;
	}
}
