package sim.util.doubledistribution;

import sim.util.intdistribution.IntDistribution;
import ec.util.*;

/**
 * This is an adaptor: it contains an integer-producing 
 * random number generator (<code>IntDistribution</code>), 
 * and returns those integers as doubles.
 * 
 * @author Gabriel Catalin Balan
 */
public class IntDistributionPlugIn extends DoubleDistribution
{
	IntDistribution intD;

	public static final String P_UNIF = "int-distibution-plugin";
	public static final String P_INTD = "plugin";

	public Parameter defaultBase(){	return new Parameter(P_UNIF);}
	
	public void setup(ParameterDatabase parameters, Parameter base, MersenneTwisterFast random)
	{	
		//I don't care about super.setup, cause this one does not use any randomness DIRECTLY.
		Parameter def = defaultBase();
		Parameter p;
		intD = (IntDistribution)parameters.getInstanceForParameter(p=base.push(P_INTD), def.push(P_INTD), IntDistribution.class);
		intD.setup(parameters, p, random);
	}
	
	public double getDouble(){return intD.getInt();}
}
