package sim.util.intdistribution;

import ec.util.*;

/**
 * @author Gabriel Catalin Balan
 *
 */
public class UniformIntDistribution extends IntDistribution
{
	int min;
	int max;

	public static final String P_UNIF = "distibution.uniform";
	public static final String P_MIN = "min";
	public static final String P_MAX = "max";

	public Parameter defaultBase(){	return new Parameter(P_UNIF);}
	
	public void setup(ParameterDatabase parameters, Parameter base, MersenneTwisterFast random)
	{	
		super.setup(parameters, base, random);
		Parameter def = defaultBase();
		min = parameters.getInt(base.push(P_MIN), def.push(P_MIN));
		if(min<0) throw new RuntimeException("min too small");
		max = parameters.getInt(base.push(P_MAX), def.push(P_MAX));
		if(max<min)
			throw new RuntimeException("max too small");
	}
	
	public int getInt()
	{
		return (min!=max)? rng.nextInt(max-min+1)+min : min;
		//+1 because I want to be able to reach max, as well as min.
	}
}
