package sim.util.jfreechart;
import java.io.*;
import java.awt.*;
import java.awt.geom.*;

import javax.swing.JPanel;

import com.lowagie.text.*;
import com.lowagie.text.pdf.*;
import org.jfree.chart.*;

/**
 * @author Gabriel Balan
 *
 */
public class PDFPrinter
{
	static public void printChartToPDF( JFreeChart chart, String fileName )
	{
		printChartToPDF(new ChartPanel(chart), fileName);
	}

	static public void printChartToPDF( ChartPanel panel, String fileName )
	{
		Dimension size = panel.getPreferredSize();
		printChartToPDF(panel.getChart(), size.width, size.height, fileName);
	}
	
	

	static public void printChartToPDF( JFreeChart chart, int width, int height, String fileName )
	{
		try
		{
			Document document = new Document(new com.lowagie.text.Rectangle(width,height));
			PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(fileName));
			document.addAuthor("MASON");
			document.open();
			PdfContentByte cb = writer.getDirectContent();
			PdfTemplate tp = cb.createTemplate(width, height); 
			Graphics2D g2 = tp.createGraphics(width, height, new DefaultFontMapper());
			Rectangle2D rectangle2D = new Rectangle2D.Double(0, 0, width, height); 
			chart.draw(g2, rectangle2D);
			g2.dispose();
			cb.addTemplate(tp, 0, 0);
			document.close();
		}catch( DocumentException e ){e.printStackTrace();}
		catch(FileNotFoundException e ){e.printStackTrace();}
	}
	
	
	static public void printPanelToPDF( JPanel panel, String fileName )
	{
		Dimension size = panel.getSize();
		printPanelToPDF(panel, size.width, size.height, fileName);
	}
	
	

	static public void printPanelToPDF( JPanel panel, int width, int height, String fileName )
	{
		try
		{
			Document document = new Document(new com.lowagie.text.Rectangle(width,height));
			PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(fileName));
			document.addAuthor("MASON");
			document.open();
			PdfContentByte cb = writer.getDirectContent();
			PdfTemplate tp = cb.createTemplate(width, height); 
			Graphics2D g2 = tp.createGraphics(width, height, new DefaultFontMapper());
			Rectangle2D rectangle2D = new Rectangle2D.Double(0, 0, width, height); 
			
//			panel.draw(g2, rectangle2D);			
			panel.paint(g2);
			
			g2.dispose();
			cb.addTemplate(tp, 0, 0);
			document.close();
		}catch( DocumentException e ){e.printStackTrace();}
		catch(FileNotFoundException e ){e.printStackTrace();}
	}
}
