package sim.util.stats.doubletime;
import sim.engine.*;
/**
 * @author Gabriel Catalin Balan
 * This is good for arrival rates and throughputs.
 */
public class FlowRate
{
	double startingTime;// when I started the observations
	int incomingCounter, outgoingCounter;
	Schedule schedule;
	public FlowRate(Schedule schedule)
	{
		this.schedule = schedule;
		start();
	}
		
	public void countArrival()
	{
		incomingCounter++;
	} 
	public void countDeparture()
	{
		outgoingCounter++;
	} 
	public void reset()
	{
		incomingCounter = 0;
		outgoingCounter = 0;
		startingTime = schedule.time();
	}
	public void start()
	{
		reset();
	}
	
	public double getArrivalRate()
	{
		return (double)incomingCounter/(schedule.time()-startingTime);
	}

	public double getThroughput()
	{
		return (double)outgoingCounter/(schedule.time()-startingTime);
	}
}